#ifndef NEWKBD_H
#define NEWKBD_H


#include <utils/sysglobals.h>
#include <utils/sysdevs.h>
#include <utils/misc.h>

#define nk_keylow       (-2)
#define nk_keyhigh      125
#define nk_keyshift     1
#define nk_keyctrl      2
#define nk_keyext1      4
#define nk_keymodlow    0
#define nk_keymodhigh   (nk_keyshift + nk_keyctrl)
#define nk_kknone       0
#define nk_kknormal     1
#define nk_kkesc        2
#define nk_kkprog       3
#define nk_kkcmd        4
#define nk_kkproc       5
#define nk_ktcurrent    0
#define nk_ktstandard   1
#define nk_ktcaged      2
#define nk_ktsupplied   (-1)

typedef struct nk_keyinforec {
    uchar k, c;
} nk_keyinforec;

typedef nk_keyinforec nk_keyinfovector[nk_keymodhigh - nk_keymodlow + 1];

typedef nk_keyinfovector nk_keymatrix[nk_keyhigh - nk_keylow + 1];

typedef uchar nk_keycapsvector[(nk_keyhigh - nk_keylow + 8) / 8];

typedef struct nk_keytransinfo {
    nk_keymatrix matrix;
    nk_keycapsvector caps;
    short rpgbufsize;
} nk_keytransinfo;

int nk_capslock;

#define nk_keybufsize m_pollkbd
void nk_keybufclear ();
#define nk_getkey m_inkey
void nk_ungetkey (uchar c);
#define nk_testkey(x)        m_testkey()
#define nk_gotoxy(x,y)      nc_gotoXY(x,y)
#define nk_getxy(x,y)       nc_getXY(x,y)
int nk_setcapslock (int newcaps);
void nk_settransarray (int opcode, nk_keytransinfo **table);

#endif /*NEWKBD_H*/



