#ifndef LOGDIG_H
#define LOGDIG_H

#include "logdef.h"
#include <utils/sysglobals.h>

#ifdef LOGDIG_G
# define vextern
#else
# define vextern extern
#endif



#define log_16_simtype  16


typedef enum {
  log_none, log_zero, log_one
} log_16_value;
typedef short log_16_viarr[(long)log_one - (long)log_none + 1];
typedef log_16_value log_16_ivarr[4];
typedef int log_16_vbarr[(long)log_one - (long)log_none + 1];
typedef log_16_value log_16_bvarr[2 - false];

typedef struct log_16_kindinfo {
  na_long info;
  char internally_defined_stuff;
} log_16_kindinfo;

typedef enum {
  act_16_new, act_16_dispose, act_16_copy, act_16_read, act_16_write,
  act_16_sim, act_16_draw, act_16_erase, act_16_touch, act_16_configgate,
  act_16_configchgate, act_16_configrelgate, act_16_connect,
  act_16_disconnect, act_16_reset, act_16_refnodes, act_16_gengate,
  act_16_newkind, act_16_disposekind, act_16_genkind, act_16_cnf,
  act_16_immed, act_16_func
} log_16_actionkinds;

typedef struct log_16_action {
  log_16_actionkinds action;
  log_action_t *lact;
  void (*hook_input) (log_action_t *lact, log_nrec *n, log_16_value *v);
  void (*hook_output) (log_action_t *lact, log_nrec *n, log_16_value v);
  void (*hook_ocoutput) (log_action_t *lact, log_nrec *n, log_16_value v);
  void (*hook_led) (log_action_t *lact, short x, short y, log_16_value v);
  void (*hook_eraled) (log_action_t *lact, short x, short y);
  void (*hook_plotled) (log_action_t *lact, short x, short y, log_16_value v);
} log_16_action;

vextern const log_16_viarr log_16_vi;
vextern const log_16_ivarr log_16_iv;
vextern const log_16_vbarr log_16_vb;
vextern const log_16_bvarr log_16_bv;

#undef vextern

#endif /*LOGDIG_H*/


