#ifndef NODE_H
#define NODE_H

#include "logdef.h"
#include "logstructs.h"
#include "tool.h"

typedef struct log_nrec {
  struct log_nrec *next;
  na_long info;
  log_tool *simtype;
  log_nrec *confnext;
  short ref;
  log_gattrrec *attr;
  na_long temp;
  unsigned changed : 1, conflict : 1, oconflict : 1, flag : 1, keep : 1,
	   conflict1 : 1, conflict2 : 1, f8 : 1, f7 : 1, f6 : 1, f5 : 1,
	   f4 : 1, f3 : 1, f2 : 1, f1 : 1, f0 : 1;
} log_nrec;   /* Node */


void dumpnodes();

void switchnode(log_nrec **n, log_nrec *n2);

void disposenode(log_nrec **n);

void copynode(log_nrec *old, log_nrec **n);

void newnode(log_nrec **n, uchar st);

log_nrec *refnode(log_nrec *n);

void unrefnode(log_nrec **n);

int nodeexists(log_nrec *node);

/* Local variables for checkcombine: */
struct LOC_checkcombine {
	cnrec **cnbase;
	short passcount;
	int good;
	log_tool *cursimtype;
};

int checkcombine(cnrec **cnbase_);
void queuecombine(cnrec **cnbase, log_nrec **n, log_nrec **n2);
void newnoderef(log_nrec **n, uchar st, long ref);
void delgetnode(log_nrec **save, log_nrec **old, log_nrec **n);
void checknode(log_nrec *n, struct LOC_checkcombine *LINK);
int trycombinenodes(log_nrec **n1, log_nrec **n2);
void reportnodeconflict(log_nrec *n);
void getnodeval(log_nrec *n, double *val, char *opts);

#endif
